#ifdef __STDC__
/* From fastDNAml */
#include <string.h>
#include "ml.h"

extern void   *tipValPtr      (nodeptr      p);
extern int     cmpTipVal      (void        *v1,      void    *v2);
extern topol  *setupTopol     (int          maxtips, int      nsites);
extern void    freeTopol      (topol       *tpl);
extern int     saveSubtree    (nodeptr      p,       topol   *tpl);
extern nodeptr minSubtreeTip  (nodeptr      p0);
extern nodeptr minTreeTip     (nodeptr      p);
extern void    saveTree       (tree        *tr,      topol   *tpl);
extern void    copyTopol      (topol       *tpl1,    topol   *tpl2);
extern boolean restoreTree    (topol       *tpl,     tree    *tr);
extern int     initBestTree   (bestlist    *bt,      int      newkeep,
		        int          numsp,   int      sites);
extern void    resetBestTree  (bestlist    *bt);
extern boolean freeBestTree   (bestlist    *bt);
extern int     cmpSubtopol    (connptr      p10,     connptr  p1,
		        connptr      p20,     connptr  p2);
extern int     cmpTopol       (void        *tpl1,    void    *tpl2);
extern int     cmpTplScore    (void        *tpl1,    void    *tpl2);
extern int     findInList     (void        *item,    void    *list[],
		        int          n,       
		        int        (*cmpFunc)(void    *v1, void *v2));
extern int     findTreeInList (bestlist    *bt,      tree    *tr);
extern int     saveBestTree   (bestlist    *bt,      tree    *tr);
extern int     startOpt       (bestlist    *bt,      tree    *tr);
extern int     setOptLevel    (bestlist    *bt,      int      opt_level);
extern int     recallBestTree (bestlist    *bt,      int      rank,
		        tree        *tr);
#if 0
extern void    hang           (char        *msg);
#endif
extern boolean getnums        (rawDNA      *rdta);
extern boolean digitchar      (int          ch);
extern boolean whitechar      (int          ch);
extern void    uppercase      (int         *chptr);
extern int     base36         (int          ch);
extern int     base36_2       (int          c1, int  c2);
extern int     base36_3       (int          c1, int  c2, int c3);
extern int     itobase36      (int          i);
extern char   *itobase36_str  (int          i);
extern int     findch         (int          c);
#if ! Sequential
extern int     str_findch     (char       **treestrp,int     c); 
#endif
extern boolean inputboot      (analdef     *adef);
extern boolean inputcategories(rawDNA      *rdta);
extern boolean inputextra     (analdef     *adef);
extern boolean inputfreqs     (rawDNA      *rdta);
extern boolean inputglobal    (tree        *tr);
extern boolean inputjumble    (analdef     *adef);
extern boolean inputkeep      (analdef     *adef);
extern boolean inputoutgroup  (analdef     *adef,    tree   *tr);
extern boolean inputratio     (rawDNA      *rdta);
extern boolean inputtreeopt   (analdef     *adef);
extern boolean inputweights   (analdef     *adef,    rawDNA *rdta,
			crunchedDNA *cdta);
extern boolean getoptions     (analdef     *adef,    rawDNA *rdta,
			crunchedDNA *cdta,    tree   *tr);
extern boolean getbasefreqs   (rawDNA      *rdta);
extern boolean getyspace      (rawDNA      *rdta);
extern boolean setupTree      (tree        *tr,      int     nsites);
extern void    freeTreeNode   (nodeptr      p);
extern void    freeTree       (tree        *tr);
extern boolean getdata        (analdef     *adef,    rawDNA *rdta,
			tree        *tr);
extern boolean getntrees      (analdef     *adef);
extern boolean getinput       (analdef     *adef,    rawDNA *rdta,
			crunchedDNA *cdta,    tree   *tr);
extern void    makeboot       (analdef     *adef,    rawDNA *rdta,
			crunchedDNA *cdta);
extern void    sitesort       (rawDNA      *rdta,    crunchedDNA *cdta);
extern void    sitecombcrunch (rawDNA      *rdta,    crunchedDNA *cdta);
extern boolean makeweights    (analdef     *adef,    rawDNA *rdta,
			crunchedDNA *cdta);
extern boolean makevalues     (rawDNA      *rdta,    crunchedDNA *cdta);
extern boolean empiricalfreqs (rawDNA      *rdta,    crunchedDNA *cdta);
extern void    reportfreqs    (analdef     *adef,    rawDNA *rdta,
			       crunchedDNA *cdta);
extern boolean linkdata2tree  (rawDNA      *rdta,    crunchedDNA *cdta,
			tree        *tr);
extern xarray *setupxarray    (int          npat);
extern boolean linkxarray     (int          req,     int     min,
			int          npat,    xarray**freexptr,
			xarray     **usedxptr);
extern boolean setupnodex     (tree        *tr);
extern xarray *getxtip        (nodeptr      p);
extern xarray *getxnode       (nodeptr      p);
extern boolean newview        (tree        *tr,      nodeptr p);
extern double  evaluate       (tree        *tr,      nodeptr p);
extern double  makenewz       (tree        *tr,      nodeptr p,
			nodeptr      q,       double  z0,
			int          maxiter);
extern boolean update         (tree        *tr,      nodeptr p);
extern boolean smooth         (tree        *tr,      nodeptr p);
extern boolean smoothTree     (tree        *tr,      int     maxtimes);
extern boolean localSmooth    (tree        *tr,      nodeptr p,
			int          maxtimes);
extern void    hookup         (nodeptr      p,       nodeptr q,
			double       z);
extern boolean insert         (tree        *tr,      nodeptr p,
			nodeptr      q,       boolean glob);
extern nodeptr removeNode     (tree        *tr,      nodeptr p);
extern boolean initrav        (tree        *tr,      nodeptr p);
extern nodeptr buildNewTip    (tree        *tr,      nodeptr p);
extern boolean buildSimpleTree(tree        *tr,      int     ip,
			int          iq,      int     ir);
#ifdef NEED_STR
extern char   *strchr         (char        *str,     int     chr);
extern char   *strstr         (char        *str1,    const char *str2);
#endif
extern boolean readKeyValue   (char        *string,  const char *key,
			const char  *format,  void   *value);
#if ! Sequential
extern double  str_readTreeLikelihood(char *treestr); 
extern boolean sendTree       (comm_block  *comm,    tree   *tr);
extern boolean receiveTree    (comm_block  *comm,    tree   *tr);
extern void    requestForWork (void);
extern void    sendTreeNum    (int          n_to_get);
extern boolean getReturnedTrees(tree       *tr,      bestlist *bt,
			int          n_tree_sent);
#endif
extern void    cacheZ         (tree        *tr);
extern void    restoreZ       (tree        *tr);
extern boolean testInsert     (tree        *tr,      nodeptr p,
			nodeptr      q,       bestlist *bt,
			boolean      fast);
extern int     addTraverse    (tree        *tr,      nodeptr p,
			nodeptr      q,       int     mintrav,
			int          maxtrav, bestlist *bt,
			boolean      fast);
extern int     rearrange      (tree        *tr,      nodeptr p,
			int          mintrav, int     maxtrav,
			bestlist    *bt);
extern FILE   *fopen_pid      (const char  *filenm,  const char *mode,
			char        *name_pid);
#if DeleteCheckpointFile
extern void    unlink_pid     (char        *filenm);
#endif
extern void    writeCheckpoint(tree        *tr);
extern node   *findAnyTip     (nodeptr      p);
extern boolean optimize       (tree        *tr,      int     maxtrav,
			bestlist    *bt);
extern void    coordinates    (tree        *tr,      nodeptr p,
			double       lengthsum, drawdata *tdptr);
extern void    drawline       (tree        *tr,      int     i,
			double       scale);
extern void    printTree      (tree        *tr,      analdef*adef);
extern double  sigma          (tree        *tr,      nodeptr p,
			double      *sumlrptr);
extern void    describe       (tree        *tr,      nodeptr p);
extern void    summarize      (tree        *tr);
extern char   *treeString     (char        *treestr, tree   *tr,
			nodeptr      p,       int     form);
extern void    treeOut        (FILE        *treefile,tree   *tr,
			int          form);
extern int     treeFinishCom  (FILE        *fp,      char  **strp);
extern int     treeGetCh      (FILE        *fp);
extern boolean treeLabelEnd   (int          ch);
extern boolean treeGetLabel   (FILE        *fp,      char   *lblPtr,
			int          maxlen);
extern boolean treeFlushLabel (FILE        *fp);
extern int     treeFindTipByLabel(char     *str,     tree   *tr);
extern int     treeFindTipName(FILE        *fp,      tree   *tr);
extern void    treeEchoContext(FILE        *fp1,     FILE   *fp2,
			int          n);
extern boolean treeProcessLength(FILE      *fp,      double *dptr);
extern boolean treeFlushLen   (FILE        *fp);
extern boolean treeNeedCh     (FILE        *fp,      int     c1,
			const char  *where);
extern boolean addElementLen  (FILE        *fp,      tree   *tr,
			nodeptr      p);
extern int     saveTreeCom    (char       **comstrp);
extern boolean processTreeCom (FILE        *fp,      tree   *tr);
extern nodeptr uprootTree     (tree        *tr,      nodeptr p);
extern boolean treeReadLen    (FILE        *fp,      tree   *tr);
#if ! Sequential
extern int     str_treeFinishCom(char     **treestrp,char  **strp);
extern int     str_treeGetCh  (char       **treestrp);
extern boolean str_treeGetLabel(char      **treestrp,char   *lblPtr,
		        int          maxlen);
extern boolean str_treeFlushLabel(char    **treestrp);
extern int     str_treeFindTipName(char   **treestrp,tree   *tr);
extern boolean str_treeProcessLength(char **treestrp,double *dptr);
extern boolean str_treeFlushLen(char      **treestrp);
extern boolean str_treeNeedCh (char       **treestrp,int     c1,
			       const char        *where);
extern boolean str_addElementLen(char     **treestrp,tree   *tr,
			  nodeptr    p);
extern boolean str_processTreeCom(tree     *tr,      char  **treestrp);
extern boolean str_treeReadLen(char        *treestr, tree   *tr);
#endif
extern boolean treeEvaluate   (tree        *tr,      bestlist *bt);
#if ! Sequential
extern FILE   *freopen_pid     (const char *filenam, const char *mode,
			FILE        *stream);
#endif
extern boolean showBestTrees  (bestlist    *bt,      tree    *tr,
			analdef     *adef,    FILE    *treefile);
extern boolean cmpBestTrees   (bestlist    *bt,      tree    *tr);
extern boolean makeUserTree   (tree        *tr,      bestlist *bt,
			analdef     *adef);
#if ! Sequential
extern boolean slaveTreeEvaluate(tree      *tr,      bestlist *bt);
#endif
extern double  randum         (long        *seed);
extern boolean makeDenovoTree (tree        *tr,      bestlist *bt,
			analdef     *adef);
#if Sequential
extern int     main           (void);
#else
extern int     slave          (void);
#endif

/* From merge */
int mergeslave(void);

/* From dispatch */
struct ready_queue;
struct work_queue;

void init_ready_queue(struct ready_queue *);
void put_ready_queue(struct ready_queue *, int);
boolean get_ready_queue(struct ready_queue *, int *);
void init_work_queue(struct work_queue *);
void put_work_queue(struct work_queue *, char *, int);
boolean get_work_queue(struct work_queue *, char **, int *);
int dispatchslave(void);

/* From host */

void hostmain(int, char *[]);

/* From comm_link */
#if Parallel
void open_link(comm_block *);
void close_link(comm_block *);
#if defined(SUN)
void nap(long);
#endif
void write_comm_msg(comm_block *, char *);
void read_comm_msg(comm_block *, char *);
#endif

#endif
